import { Account, NetworkType } from 'symbol-sdk';
import { Addresses, ConfigAccount, ConfigPreset, NodeAccount, NodePreset } from '../model';
import { Migration } from './BootstrapUtils';
import { Preset } from './ConfigService';
export declare class ConfigLoader {
    private static presetInfoLogged;
    generateRandomConfiguration(presetData: ConfigPreset): Promise<Addresses>;
    generateAddresses(networkType: NetworkType, size: number): ConfigAccount[];
    generateAccount(networkType: NetworkType, privateKey: string | undefined): Account;
    generateNodeAccount(presetData: ConfigPreset, index: number, nodePreset: NodePreset, networkType: NetworkType): NodeAccount;
    generateNodeAccounts(presetData: ConfigPreset, networkType: NetworkType): Promise<NodeAccount[]>;
    private static getArray;
    createPresetData(root: string, preset: Preset, assembly: string | undefined, customPresetFile: string | undefined, customPresetObject: any | undefined): ConfigPreset;
    dynamicDefaultNodeConfiguration(nodes?: NodePreset[]): NodePreset[];
    private resolveRoles;
    static toConfig(account: Account): ConfigAccount;
    expandRepeat(presetData: ConfigPreset): ConfigPreset;
    applyValueTemplate(context: any, value: any): any;
    expandServicesRepeat(context: any, services: any[]): any[];
    loadExistingPresetDataIfPreset(target: string): ConfigPreset | undefined;
    loadExistingPresetData(target: string): ConfigPreset;
    loadExistingAddressesIfPreset(target: string): Addresses | undefined;
    migrateAddresses(addresses: any, networkType: NetworkType): Addresses;
    getAddressesMigration(networkType: NetworkType): Migration[];
    loadExistingAddresses(target: string): Addresses;
    getGeneratedPresetLocation(target: string): string;
    getGeneratedAddressLocation(target: string): string;
}
